# readRGA.py Ed May 5 Nov 2011
# to read serial protocol data from Spectra VACSCAN RGA via PC COM1 port.
import sys
import string
import time
import serial
ser = serial.Serial(0,baudrate=9600,timeout=2)
##ser.baudrate = 9600
##ser.port = 0		# maps to COM1 port on Windows7
##ser
##ser.open()

# Openn a file for output in append mode, no buffering
fo = open("readRGA.dat", "a", 0) 

nsent=ser.write("(S)")	# get status
sSrecv=ser.read(20)	# may rely on timeout to complete
print sSrecv

nsent=ser.write("(M1)")	# get USER PEAKS
M1recv=ser.read(20)	# may rely on timeout to complete
sM1recv=""
print sM1recv

nsent=ser.write("(P)")
recv=ser.read(60)	# relies on timeout to complete

print "Start : %s" % time.ctime()
StartTime = time.ctime()
delayTime=1800
delayTime=30
print "Will use Delay time of %d sec" % delayTime
countMax =48
length = countMax*delayTime
print "Will run for %d seconds or %d minuits or %d hours." % (length, length/60, length/3600)
count = 0
timeInSec = 0
time.sleep( 5 )	# sleep for 5 sec to settle
while count < countMax :
   nsent = ser.write("(P0)")		# get Total Pressure
   sTotalPres=ser.read(12)
   s1 = string.replace(sTotalPres,'A','')	# get rid of leading A
   s2 = string.replace(s1,'\r','')
   sTP = string.replace(s2,'\n','')
   #sPrecv =  s="A1.3E-09\r\n1.3E-10\r\n6.3E-09\r\n6.3E-09\r\n0.6E-09\r\n0.1E-10\r\n\n"
   nsent=ser.write("(P)")
   sPrecv=ser.read(60)	# relies on timeout to complete
   s2 = string.replace(sPrecv,'A','') 	# get rid of leading 'A'
   #print sPrecv
   #print s2
   s3 = string.replace(s2,'\n','')	# remove '\n' characters ie newline
   list3 = string.split(s3,'\r')	# split fields on '\r' character ie carriage return
   #print list3
   #print 'first element is ', list3[0]
   print count,timeInSec,sTP,list3[0],list3[1],list3[2],list3[3],list3[4],list3[5],time.ctime()
   fo.write( "%d %d %s %s %s %s %s %s %s %s\n" % (count,timeInSec,sTP,list3[0],list3[1],list3[2],list3[3],list3[4],list3[5],time.ctime()) )
   count = count + 1
   time.sleep( delayTime )	# sleep for  sec
   timeInSec = timeInSec + delayTime
   
#ser.close()

print "Started: %s" %  StartTime
print "Ended  : %s" % time.ctime()
print "Used Delay time of %d (sec)" % delayTime 
print "Run time was  %d seconds or %d minuits or %d hours." % (length, length/60, length/3600)

fo.close()

sys.exit(0)

